<?php
/**
*
* @clean SQL  database phpBB3 from MODS
* @version $ 0.0.1 BETA $
* almsamim.com - web developer
* @copyright (c) 2005 phpBB Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/

define('IN_PHPBB', true);
define('MOD_DB_CLEAN_WORK_WITH', '3.0.5'); //work on this version or less !
$phpbb_root_path = './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup('common');
// Authorication
if (!$auth->acl_get('a_'))
{
	trigger_error($user->lang['NOT_AUTHORISED']);
}

//not comptiable with current version
$_n_c_ = (version_compare(str_replace('rc', 'RC', strtolower($config['version'])), str_replace('rc', 'RC', strtolower(MOD_DB_CLEAN_WORK_WITH)), '<=')) ? false : true;
 
if($_n_c_)
{
	trigger_error('This mod work with version ' . MOD_DB_CLEAN_WORK_WITH . ' or less .');
}

$db->sql_return_on_error(true);

// default tables in phpBB database
    $default_table= array(
	"1" => $table_prefix."acl_groups" ,
	"2" => $table_prefix."acl_options",
	"3" => $table_prefix."acl_roles" ,
	"4" => $table_prefix."acl_roles_data" ,
	"5" => $table_prefix."acl_users" ,
	"6" => $table_prefix."attachments" ,
	"7" => $table_prefix."banlist" ,
	"8" => $table_prefix."bbcodes" ,
	"9" => $table_prefix."bookmarks" ,
	"10" => $table_prefix."bots" ,
	"11" => $table_prefix."config" ,
	"12" => $table_prefix."confirm" ,
	"13" => $table_prefix."disallow" ,
	"14" => $table_prefix."drafts" ,
	"15" => $table_prefix."extension_groups" ,
	"16" => $table_prefix."extensions" ,
	"17" => $table_prefix."forums" ,
	"18" => $table_prefix."forums_access" ,
	"19" => $table_prefix."forums_track" ,
	"20" => $table_prefix."forums_watch" ,
	//added some columns in 3.0.3 : group_max_recipients
	"21" => $table_prefix."groups" ,
	"22" => $table_prefix."icons" ,
	"23" => $table_prefix."lang" ,
	"24" => $table_prefix."log" ,
	"25" => $table_prefix."moderator_cache" ,
	"26" => $table_prefix."modules" ,
	"27" => $table_prefix."poll_options" ,
	"28" => $table_prefix."poll_votes" ,
	"29" => $table_prefix."posts" ,
	"30" => $table_prefix."privmsgs" ,
	"31" => $table_prefix."privmsgs_folder" ,
	"32" => $table_prefix."privmsgs_rules" ,
	"33" => $table_prefix."privmsgs_to" ,
	//added some columns in 3.0.4 : field_show_profile
	"34" => $table_prefix."profile_fields" ,
	"35" => $table_prefix."profile_fields_data" ,
	"36" => $table_prefix."profile_fields_lang" ,
	"37" => $table_prefix."profile_lang" ,
	"38" => $table_prefix."ranks" ,
	"39" => $table_prefix."reports" ,
	"40" => $table_prefix."reports_reasons" ,
	"41" => $table_prefix."search_results" ,
	"42" => $table_prefix."search_wordlist" ,
	"43" => $table_prefix."search_wordmatch" ,
	"44" => $table_prefix."sessions" ,
	"45" => $table_prefix."sessions_keys" ,
	"46" => $table_prefix."sitelist" ,
	"47" => $table_prefix."smilies" ,
	"48" => $table_prefix."styles" ,
	"49" => $table_prefix."styles_imageset" ,
	"50" => $table_prefix."styles_imageset_data" ,
	//added some columns in 3.0.3 : template_inherits_id, group_max_recipients
	"51" => $table_prefix."styles_template" ,
	"52" => $table_prefix."styles_template_data" ,
	"53" => $table_prefix."styles_theme" ,
	"54" => $table_prefix."topics" ,
	"55" => $table_prefix."topics_posted" ,
	"56" => $table_prefix."topics_track" ,
	"57" => $table_prefix."topics_watch" ,
	"58" => $table_prefix."user_group" ,
	"59" => $table_prefix."users" ,
	"60" => $table_prefix."warnings" ,
	"61" => $table_prefix."words" ,
	"62" => $table_prefix."zebra" 
	);    
	//default fields in phpBB3
	$default_field= array(
	$table_prefix."acl_groups" => array('group_id','forum_id','auth_option_id','auth_role_id','auth_setting'),
	$table_prefix."acl_options" => array('auth_option_id','auth_option','is_global','is_local','founder_only'),
	$table_prefix."acl_roles" => array('role_id','role_name','role_description','role_type','role_order'),
	$table_prefix."acl_roles_data" => array('role_id','auth_option_id','auth_setting'),
	$table_prefix."acl_users" => array('user_id','forum_id','auth_option_id','auth_role_id','auth_setting'),
	$table_prefix."attachments" => array('attach_id','post_msg_id','topic_id','in_message','poster_id','is_orphan','physical_filename','real_filename','download_count','attach_comment','extension','mimetype','filesize','filetime','thumbnail'),
	$table_prefix."banlist" => array('ban_id','ban_userid','ban_ip','ban_email','ban_start','ban_end','ban_exclude','ban_reason','ban_give_reason'),
	$table_prefix."bbcodes" => array('bbcode_id','bbcode_tag','bbcode_helpline','display_on_posting','bbcode_match','bbcode_tpl','first_pass_match','first_pass_replace','second_pass_match','second_pass_replace'),
	$table_prefix."bookmarks" => array('topic_id','user_id'),
	$table_prefix."bots" => array('bot_id','bot_active','bot_name','user_id','bot_agent','bot_ip'),
	$table_prefix."config" => array('config_name','config_value','is_dynamic'),
	$table_prefix."confirm" => array('Full Texts','confirm_id','session_id','confirm_type','code','seed'),
	$table_prefix."disallow" => array('disallow_id','disallow_username'),
	$table_prefix."drafts" => array('draft_id','user_id','topic_id','forum_id','save_time','draft_subject','draft_message'),
	$table_prefix."extension_groups" => array('Full Texts','group_id','group_name','cat_id','allow_group','download_mode','upload_icon','max_filesize','allowed_forums','allow_in_pm'),
	$table_prefix."extensions" => array('extension_id','group_id','extension'),
	$table_prefix."forums" => array('forum_id','parent_id','left_id','right_id','forum_parents','forum_name','forum_desc','forum_desc_bitfield','forum_desc_options','forum_desc_uid','forum_link','forum_password','forum_style','forum_image','forum_rules','forum_rules_link','forum_rules_bitfield','forum_rules_options','forum_rules_uid','forum_topics_per_page','forum_type','forum_status','forum_posts','forum_topics','forum_topics_real','forum_last_post_id','forum_last_poster_id','forum_last_post_subject','forum_last_post_time','forum_last_poster_name','forum_last_poster_colour','forum_flags','display_subforum_list','display_on_index','enable_indexing','enable_icons','enable_prune','prune_next','prune_days','prune_viewed','prune_freq'),
	$table_prefix."forums_access" => array('forum_id','user_id','session_id'),
	$table_prefix."forums_track" => array('user_id','forum_id','mark_time'),
	$table_prefix."forums_watch" => array('forum_id','user_id','notify_status'),
	$table_prefix."groups" => array('group_id','group_type','group_founder_manage','group_name','group_desc','group_desc_bitfield','group_desc_options','group_desc_uid','group_display','group_avatar','group_avatar_type','group_avatar_width','group_avatar_height','group_rank','group_colour','group_sig_chars','group_receive_pm','group_message_limit', 'group_max_recipients', 'group_legend'),
	$table_prefix."icons" => array('icons_id','icons_url','icons_width','icons_height','icons_order','display_on_posting'),
	$table_prefix."lang" => array('lang_id','lang_iso','lang_dir','lang_english_name','lang_local_name','lang_author'),
	$table_prefix."log" => array('log_id','log_type','user_id','forum_id','topic_id','reportee_id','log_ip','log_time','log_operation','log_data'),
	$table_prefix."moderator_cache" => array('forum_id','user_id','username','group_id','group_name','display_on_index'),
	$table_prefix."modules" => array('module_id','module_enabled','module_display','module_basename','module_class','parent_id','left_id','right_id','module_langname','module_mode','module_auth'),
	$table_prefix."poll_options" => array('poll_option_id','topic_id','poll_option_text','poll_option_total'),
	$table_prefix."poll_votes" => array('topic_id','poll_option_id','vote_user_id','vote_user_ip'),
	$table_prefix."posts" => array('post_id','topic_id','forum_id','poster_id','icon_id','poster_ip','post_time','post_approved','post_reported','enable_bbcode','enable_smilies','enable_magic_url','enable_sig','post_username','post_subject','post_text','post_checksum','post_attachment','bbcode_bitfield','bbcode_uid','post_postcount','post_edit_time','post_edit_reason','post_edit_user','post_edit_count','post_edit_locked'),
	$table_prefix."privmsgs" => array('msg_id','root_level','author_id','icon_id','author_ip','message_time','enable_bbcode','enable_smilies','enable_magic_url','enable_sig','message_subject','message_text','message_edit_reason','message_edit_user','message_attachment','bbcode_bitfield','bbcode_uid','message_edit_time','message_edit_count','to_address','bcc_address'),
	$table_prefix."privmsgs_folder" => array('folder_id','user_id','folder_name','pm_count'),
	$table_prefix."privmsgs_rules" => array('rule_id','user_id','rule_check','rule_connection','rule_string','rule_user_id','rule_group_id','rule_action','rule_folder_id'),
	$table_prefix."privmsgs_to" => array('msg_id','user_id','author_id','pm_deleted','pm_new','pm_unread','pm_replied','pm_marked','pm_forwarded','folder_id'),
	$table_prefix."profile_fields" => array('field_id','field_name','field_type','field_ident','field_length','field_minlen','field_maxlen','field_novalue','field_default_value','field_validation','field_required','field_show_on_reg','field_hide','field_no_view','field_active','field_order'),
	$table_prefix."profile_fields" => array('field_id','field_name','field_type','field_ident','field_length','field_minlen','field_maxlen','field_novalue','field_default_value','field_validation','field_required','field_show_on_reg','field_show_profile','field_hide','field_no_view','field_active','field_order'),
	$table_prefix."profile_fields_data" => array('user_id'),
	$table_prefix."profile_fields_lang" => array('field_id','lang_id','option_id','field_type','lang_value'),
	$table_prefix."profile_lang" => array('field_id','lang_id','lang_name','lang_explain','lang_default_value'),
	$table_prefix."ranks" => array('rank_id','rank_title','rank_min','rank_special','rank_image'),
	$table_prefix."reports" => array('report_id','reason_id','post_id','user_id','user_notify','report_closed','report_time','report_text'),
	$table_prefix."reports_reasons" => array('reason_id','reason_title','reason_description','reason_order'),
	$table_prefix."search_results" => array('search_key','search_time','search_keywords','search_authors'),
	$table_prefix."search_wordlist" => array('word_id','word_text','word_common','word_count'),
	$table_prefix."search_wordmatch" => array('post_id','word_id','title_match'),
	$table_prefix."sessions" => array('session_id','session_user_id','session_forum_id','session_last_visit','session_start','session_time','session_ip','session_browser','session_forwarded_for','session_page','session_viewonline','session_autologin','session_admin'),
	$table_prefix."sessions_keys" => array('key_id','user_id','last_ip','last_login'),
	$table_prefix."sitelist" => array('site_id','site_ip','site_hostname','ip_exclude'),
	$table_prefix."smilies" => array('Full Texts ','smiley_id','code','emotion','smiley_url','smiley_width','smiley_height','smiley_order','display_on_posting'),
	$table_prefix."styles" => array('style_id','style_name','style_copyright','style_active','template_id','theme_id','imageset_id'),
	$table_prefix."styles_imageset" => array('imageset_id','imageset_name','imageset_copyright','imageset_path'),
	$table_prefix."styles_imageset_data" => array('image_id','image_name','image_filename','image_lang','image_height','image_width','imageset_id'),
	$table_prefix."styles_template" => array('template_id','template_name','template_copyright','template_path','bbcode_bitfield','template_storedb', 'template_inherits_id', 'template_inherit_path'),
	$table_prefix."styles_template_data" => array('template_id','template_filename','template_included','template_mtime','template_data'),
	$table_prefix."styles_theme" => array('theme_id','theme_name','theme_copyright','theme_path','theme_storedb','theme_mtime','theme_data'),
	$table_prefix."topics" => array('topic_id','forum_id','icon_id','topic_attachment','topic_approved','topic_reported','topic_title','topic_poster','topic_time','topic_time_limit','topic_views','topic_replies','topic_replies_real','topic_status','topic_type','topic_first_post_id','topic_first_poster_name','topic_first_poster_colour','topic_last_post_id','topic_last_poster_id','topic_last_poster_name','topic_last_poster_colour','topic_last_post_subject','topic_last_post_time','topic_last_view_time','topic_moved_id','topic_bumped','topic_bumper','poll_title','poll_start','poll_length','poll_max_options','poll_last_vote','poll_vote_change'),
	$table_prefix."topics_posted" => array('user_id','topic_id','topic_posted'),
	$table_prefix."topics_track" => array('user_id','topic_id','forum_id','mark_time'),
	$table_prefix."topics_watch" => array('topic_id','user_id','notify_status'),
	$table_prefix."user_group" => array('Full Texts ','group_id','user_id','group_leader','user_pending'),
	$table_prefix."users" => array('user_id','user_type','group_id','user_permissions','user_perm_from','user_ip','user_regdate','username','username_clean','user_password','user_passchg','user_pass_convert','user_email','user_email_hash','user_birthday','user_lastvisit','user_lastmark','user_lastpost_time','user_lastpage','user_last_confirm_key','user_last_search','user_warnings','user_last_warning','user_login_attempts','user_inactive_reason','user_inactive_time','user_posts','user_lang','user_timezone','user_dst','user_dateformat','user_style','user_rank','user_colour','user_new_privmsg','user_unread_privmsg','user_last_privmsg','user_message_rules','user_full_folder','user_emailtime','user_topic_show_days','user_topic_sortby_type','user_topic_sortby_dir','user_post_show_days','user_post_sortby_type','user_post_sortby_dir','user_notify','user_notify_pm','user_notify_type','user_allow_pm','user_allow_viewonline','user_allow_viewemail','user_allow_massemail','user_options','user_avatar','user_avatar_type','user_avatar_width','user_avatar_height','user_sig','user_sig_bbcode_uid','user_sig_bbcode_bitfield','user_from','user_icq','user_aim','user_yim','user_msnm','user_jabber','user_website','user_occ','user_interests','user_actkey','user_newpasswd','user_form_salt'),
	$table_prefix."warnings" => array('warning_id','user_id','post_id','log_id','warning_time'),
	$table_prefix."words" => array('word_id','word','replacement'),
	$table_prefix."zebra" => array('user_id','zebra_id','friend','foe'),
	);
	
	//default phpbb_config values ih phpBB
	$default_config = array(
	'1' => 'active_sessions',
	'2' => 'allow_attachments',
	'3' => 'allow_autologin',
	'4' => 'allow_avatar_local',
	'5' => 'allow_avatar_remote',
	'6' => 'allow_avatar_upload',
	'7' => 'allow_bbcode',
	'8' => 'allow_birthdays',
	'9' => 'allow_bookmarks',
	'10' => 'allow_emailreuse',
	'11' => 'allow_forum_notify',
	'12' => 'allow_mass_pm',
	'13' => 'allow_name_chars',
	'14' => 'allow_namechange',
	'15' => 'allow_nocensors',
	'16' => 'allow_pm_attach',
	'17' => 'allow_post_flash',
	'18' => 'allow_post_links',
	'19' => 'allow_privmsg',
	'20' => 'allow_sig',
	'21' => 'allow_sig_bbcode',
	'22' => 'allow_sig_flash',
	'23' => 'allow_sig_img',
	'24' => 'allow_sig_links',
	'25' => 'allow_sig_pm',
	'26' => 'allow_sig_smilies',
	'27' => 'allow_smilies',
	'28' => 'allow_topic_notify',
	'29' => 'attachment_quota',
	'30' => 'auth_bbcode_pm',
	'31' => 'auth_flash_pm',
	'32' => 'auth_img_pm',
	'33' => 'auth_method',
	'34' => 'auth_smilies_pm',
	'35' => 'avatar_filesize',
	'36' => 'avatar_gallery_path',
	'37' => 'avatar_max_height',
	'38' => 'avatar_max_width',
	'39' => 'avatar_min_height',
	'40' => 'avatar_min_width',
	'41' => 'avatar_path',
	'42' => 'avatar_salt',
	'43' => 'board_contact',
	'44' => 'board_disable',
	'45' => 'board_disable_msg',
	'46' => 'board_dst',
	'47' => 'board_email',
	'48' => 'board_email_form',
	'49' => 'board_email_sig',
	'50' => 'board_hide_emails',
	'51' => 'board_startdate',
	'52' => 'board_timezone',
	'53' => 'browser_check',
	'54' => 'bump_interval',
	'55' => 'bump_type',
	'56' => 'cache_gc',
	'57' => 'cache_last_gc',
	'58' => 'captcha_gd',
	'59' => 'captcha_gd_foreground_noise',
	'60' => 'captcha_gd_x_grid',
	'61' => 'captcha_gd_y_grid',
	'62' => 'check_attachment_content',
	'63' => 'check_dnsbl',
	'64' => 'chg_passforce',
	'65' => 'cookie_domain',
	'66' => 'cookie_name',
	'67' => 'cookie_path',
	'68' => 'cookie_secure',
	'69' => 'coppa_enable',
	'70' => 'coppa_fax',
	'71' => 'coppa_mail',
	'72' => 'cron_lock',
	'73' => 'database_gc',
	'74' => 'database_last_gc',
	'75' => 'default_dateformat',
	'76' => 'default_lang',
	'77' => 'default_style',
	'78' => 'display_last_edited',
	'79' => 'display_order',
	'80' => 'edit_time',
	'81' => 'email_check_mx',
	'82' => 'email_enable',
	'83' => 'email_function_name',
	'84' => 'email_package_size',
	'85' => 'enable_confirm',
	'86' => 'enable_pm_icons',
	'87' => 'enable_post_confirm',
	'88' => 'flood_interval',
	'89' => 'force_server_vars',
	'90' => 'form_token_lifetime',
	'91' => 'form_token_mintime',
	'92' => 'form_token_sid_guests',
	'93' => 'forward_pm',
	'94' => 'forwarded_for_check',
	'95' => 'full_folder_action',
	'96' => 'fulltext_mysql_max_word_len',
	'97' => 'fulltext_mysql_min_word_len',
	'98' => 'fulltext_native_common_thres',
	'99' => 'fulltext_native_load_upd',
	'100' => 'fulltext_native_max_chars',
	'101' => 'fulltext_native_min_chars',
	'102' => 'gzip_compress',
	'103' => 'hot_threshold',
	'104' => 'icons_path',
	'105' => 'img_create_thumbnail',
	'106' => 'img_display_inlined',
	'107' => 'img_imagick',
	'108' => 'img_link_height',
	'109' => 'img_link_width',
	'110' => 'img_max_height',
	'111' => 'img_max_thumb_width',
	'112' => 'img_max_width',
	'113' => 'img_min_thumb_filesize',
	'114' => 'ip_check',
	'115' => 'jab_enable',
	'116' => 'jab_host',
	'117' => 'jab_package_size',
	'118' => 'jab_password',
	'119' => 'jab_port',
	'120' => 'jab_use_ssl',
	'121' => 'jab_username',
	'122' => 'last_queue_run',
	'123' => 'ldap_base_dn',
	'124' => 'ldap_email',
	'125' => 'ldap_password',
	'126' => 'ldap_port',
	'127' => 'ldap_server',
	'128' => 'ldap_uid',
	'129' => 'ldap_user',
	'130' => 'ldap_user_filter',
	'131' => 'limit_load',
	'132' => 'limit_search_load',
	'133' => 'load_anon_lastread',
	'134' => 'load_birthdays',
	'135' => 'load_cpf_memberlist',
	'136' => 'load_cpf_viewprofile',
	'137' => 'load_cpf_viewtopic',
	'138' => 'load_db_lastread',
	'139' => 'load_db_track',
	'140' => 'load_jumpbox',
	'141' => 'load_moderators',
	'142' => 'load_online',
	'143' => 'load_online_guests',
	'144' => 'load_online_time',
	'145' => 'load_onlinetrack',
	'146' => 'load_search',
	'147' => 'load_tplcompile',
	'148' => 'load_user_activity',
	'149' => 'max_attachments',
	'150' => 'max_attachments_pm',
	'151' => 'max_autologin_time',
	'152' => 'max_filesize',
	'153' => 'max_filesize_pm',
	'154' => 'max_login_attempts',
	'155' => 'max_name_chars',
	'156' => 'max_pass_chars',
	'157' => 'max_poll_options',
	'158' => 'max_post_chars',
	'159' => 'max_post_font_size',
	'160' => 'max_post_img_height',
	'161' => 'max_post_img_width',
	'162' => 'max_post_smilies',
	'163' => 'max_post_urls',
	'164' => 'max_quote_depth',
	'165' => 'max_reg_attempts',
	'166' => 'max_sig_chars',
	'167' => 'max_sig_font_size',
	'168' => 'max_sig_img_height',
	'169' => 'max_sig_img_width',
	'170' => 'max_sig_smilies',
	'171' => 'max_sig_urls',
	'172' => 'mime_triggers',
	'173' => 'min_name_chars',
	'174' => 'min_pass_chars',
	'175' => 'min_search_author_chars',
	'176' => 'newest_user_colour',
	'177' => 'newest_user_id',
	'178' => 'newest_username',
	'179' => 'num_files',
	'180' => 'num_posts',
	'181' => 'num_topics',
	'182' => 'num_users',
	'183' => 'override_user_style',
	'184' => 'pass_complex',
	'185' => 'pm_edit_time',
	'186' => 'pm_max_boxes',
	'187' => 'pm_max_msgs',
	'188' => 'posts_per_page',
	'189' => 'print_pm',
	'190' => 'queue_interval',
	'191' => 'rand_seed',
	'192' => 'rand_seed_last_update',
	'193' => 'ranks_path',
	'194' => 'record_online_date',
	'195' => 'record_online_users',
	'196' => 'referer_validation',
	'197' => 'require_activation',
	'198' => 'script_path',
	'199' => 'search_anonymous_interval',
	'200' => 'search_block_size',
	'201' => 'search_gc',
	'202' => 'search_indexing_state',
	'203' => 'search_interval',
	'204' => 'search_last_gc',
	'205' => 'search_store_results',
	'206' => 'search_type',
	'207' => 'secure_allow_deny',
	'208' => 'secure_allow_empty_referer',
	'209' => 'secure_downloads',
	'210' => 'server_name',
	'211' => 'server_port',
	'212' => 'server_protocol',
	'213' => 'session_gc',
	'214' => 'session_last_gc',
	'215' => 'session_length',
	'216' => 'site_desc',
	'217' => 'sitename',
	'218' => 'smilies_path',
	'219' => 'smtp_auth_method',
	'220' => 'smtp_delivery',
	'221' => 'smtp_host',
	'222' => 'smtp_password',
	'223' => 'smtp_port',
	'224' => 'smtp_username',
	'225' => 'topics_per_page',
	'226' => 'tpl_allow_php',
	'227' => 'upload_dir_size',
	'228' => 'upload_icons_path',
	'229' => 'upload_path',
	'230' => 'version',
	'231' => 'warnings_expire_days',
	'232' => 'warnings_gc',
	'233' => 'warnings_last_gc',
	//added in 3.0.3:
	'234' => 'enable_queue_trigger',
	'235' => 'queue_trigger_posts',
	'236' => 'pm_max_recipients',
	'237' => 'dbms_version',
	//added in 3.0.5
	'238' => 'captcha_gd_wave',	
	'239' => 'captcha_gd_3d_noise',	
	'240' => 'captcha_gd_fonts',	
	'241' => 'confirm_refresh',	
	'242' => 'max_num_search_keywords',	
	
	);

	// your tables,fields and config values arrays
	$result_table = $result_field = $result_config = $result_module = array();
	// unknow arrays
	$unknown_table = $unknown_field = $unknown_config = array();
	// unknow arrays count
	$unknown_table_c = $unknown_field_c = $unknown_config_c = $result_module_c = 0;

	$message = '<h3>Checking unknow tables ....</h3>';
	//Get all tables from database
	$sql_table = "SHOW TABLES like '".$table_prefix."%';";
	$result_table_sql = $db->sql_query($sql_table);
	// getting your tables into array
    $i_t=0;
    while ($row_table = $db->sql_fetchrow($result_table_sql))
    {
       foreach ($row_table as $key=>$value)
       {
			$i_t ++;
			$result_table[$i_t] = $value ;
       }
    }
	// unknown tables
    $unknow_table = array_diff($result_table, $default_table);
    if($unknow_table)
    {
		// get number of unknown
		$unknown_table_c = count($unknow_table);
		// delete unknow tables
		$message .="<span style='color:red;font-weight:bold'>$unknown_table_c unknown tables have been deleted and they are :</span><br />";
       foreach ($unknow_table as $key1=>$value1)
       {
          $sql = "DROP TABLE ".$value1;
          $db->sql_query($sql);
		  $message .= "Table => <b>".$value1."</b><br />";
		}
    }else{
    $message .="<span style='color:green;font-weight:bold'>No unknown tables have been found</span><br />";
    }
	$message .="<br /><h3>Checking unknow fields ....</h3>";
	
	// getting your fields into array
	for($x=1;$x<63;$x++)
	{
	    $sql_field = "SHOW FIELDS FROM ".$default_table[$x];
	    $result_field_sql = $db->sql_query($sql_field);
		$i_f=0;
		while($row_field = mysql_fetch_assoc($result_field_sql))
		{
			// getting your fields into array
			$result_field[$default_table[$x]][$i] = $row_field['Field'];
			$i_f ++;
		}
	}
	
	// drop of unknow fields
	for($y=1;$y<63;$y++)
	{
	    $unknow_field[$y] = array_diff($result_field[$default_table[$y]], $default_field[$default_table[$y]]);
		if($unknow_field[$y])
		{
			// get number of unknown
			$unknown_field_c = count($unknow_field[$y]);
			$message .="<span style='color:red;font-weight:bold'>$unknown_field_c unknown fields have been deleted from $default_table[$y] and they are :</span><br />";
		    foreach ($unknow_field[$y] as $key1=>$value1)
	        {
		        $sql1 = "ALTER TABLE `".$default_table[$y]."` DROP `".$value1."`";
		        $db->sql_query($sql1);
				$message .= "Field => <b>".$value1."</b><br />";
			}
			$message .= "<br />";
		}
		else
		{
			$message .="No unknown fields have been found in <span style='color:green;font-weight:bold'> $default_table[$y]</span><br />";
		}
	}
	
	$message .="<br /><h3>Checking unknow config values ....</h3>";
	//Get all config values of phpbb_config
    $sql_config = "select config_name from ".$table_prefix."config;";
	$result_config_sql = $db->sql_query($sql_config);
	// getting your values into array
    $i_c=0;
    while ($row_config = $db->sql_fetchrow($result_config_sql))
    {
       foreach ($row_config as $key=>$value)
       {
			$i_c ++;
			$result_config[$i_c] = $value ;
       }
    }
	// unknown config values
    $unknow_config = array_diff($result_config, $default_config);
    if($unknow_config)
    {
		// get number of unknown
		$unknown_config_c = count($unknow_config);
		// delete unknow values
		$message .="<span style='color:red;font-weight:bold'>$unknown_config_c unknown config values have been deleted and they are :</span><br />";
		foreach ($unknow_config as $key1=>$value1)
		{
			$sql2 = "DELETE FROM `".$table_prefix."config` WHERE CONVERT(`".$table_prefix."config`.`config_name` USING utf8) = '".$value1."' LIMIT 1";
			$db->sql_query($sql2);
			$message .= "config_name => <b>".$value1."</b><br />";
		}
    }
	else
	{
		$message .="<span style='color:green;font-weight:bold'>No unknown config values have been found</span><br />";
    }
	
	$message .="<br /><h3>Checking unknow Modules ....</h3>";
	//Get all unknown modules
    $sql_module = "select module_id from ".$table_prefix."modules WHERE module_id > 189;";
	$result_module_sql = $db->sql_query($sql_module);
	// getting your values into array
    $i_m=0;
	if(mysql_num_rows($result_module_sql))
	{
		while ($row_module = $db->sql_fetchrow($result_module_sql))
		{
		   foreach ($row_module as $key=>$value)
		   {
				$i_m ++;
				$result_module[$i_m] = $value ;
		   }
		}
		
		// get number of unknown
		$result_module_c = count($result_module);
		// delete unknow values
		$message .="<span style='color:red;font-weight:bold'>$result_module_c unknown Modules have been deleted and they are :</span><br />";
       foreach ($result_module as $key1=>$value1)
       {
	   	  $sql3 = "DELETE FROM `".$table_prefix."modules` WHERE `phpbb_modules`.`module_id` = ".$value1." LIMIT 1";
          $db->sql_query($sql3);
		  $message .= "Module_id => <b>".$value1."</b><br />";
		}
		$sql4 = "ALTER TABLE `".$table_prefix."modules` AUTO_INCREMENT =189";
        $db->sql_query($sql4);
    }
	else
	{
		$message .="<span style='color:green;font-weight:bold'>No unknown Modules have been found</span><br />";
    }
	
	$message .="<br /><h3>Statistics</h3>Total deleted Tables <b>$unknown_table_c</b> |Total deleted fields <b>$unknown_field_c</b> |Total deleted config values  <b>$unknown_config_c</b> |Total deleted Modules <b>$result_module_c</b> ";
	
	trigger_error($message);
?>